local SteadyClaw_ABILMAP = {
    ["Bear"] = { primary = "Bite", primaryFocus = 35, spamable = "Claw", spamableFocus = 25 },
    ["Boar"] = { primary = "Bite", primaryFocus = 35, spamable = "Gore", spamableFocus = 25 },
    ["Cat"] = { primary = "Bite", primaryFocus = 35, spamable = "Claw", spamableFocus = 25 },
    ["Raptor"] = { primary = "Bite", primaryFocus = 35, spamable = "Claw", spamableFocus = 25 },
    ["Ravager"] = { primary = "Bite", primaryFocus = 35, spamable = "Gore", spamableFocus = 25 },
    ["Scorpid"] = { primary = "Scorpid Poison", primaryFocus = 30, spamable = "Claw", spamableFocus = 25 },
    ["Warp Stalker"] = { primary = "Bite", primaryFocus = 35, spamable = "Claw", spamableFocus = 25 },
}

function SteadyClaw(debug)
    local abilMap = SteadyClaw_ABILMAP[UnitCreatureFamily("pet")]
    
    if not abilMap then
        if debug then Print("Improper pet family") end
        return
    end
    
    local actionIndex, actionName, primaryIndex
    for actionIndex = 1, NUM_PET_ACTION_SLOTS do
        actionName = GetPetActionInfo(actionIndex)
        if actionName == abilMap.primary then
            primaryIndex = actionIndex
            break
        end 
    end -- for index
    
    -- can't find our things
    if not primaryIndex then
        if debug then Print("Can't find primary index") end
        return 
    end
       
    -- First check to see if the primary action has less than global cooldown left
    local startTime, duration, enbl = GetPetActionCooldown(primaryIndex)
    if startTime == 0 or duration == 0 then 
        if debug then Print("Primary action ready!") end
        return
    end
    
    -- Save the time so it is constant through the execution of this code
    local currTime = GetTime()

    local durationRemaining = (startTime + duration) - currTime
    if durationRemaining <= 1.0 then 
        if debug then Print("Primary action almost ready") end
        return 
    end
         
    -- Finally check that we have enough focus
    if UnitMana("pet") >= (abilMap.primaryFocus + abilMap.spamableFocus) then
        if debug then Print(currTime.." Casting spamable") end
        return CastSpellByName(abilMap.spamable, "pettarget")
    end
end

-- TODO: Maybe on PET_BAR_UPDATE or PET_BAR_HIDEGRID cache the indexes of the 
-- actions we want to use rather than searching on every spam
